<template>
  <el-main>
    <!--听证笔录-->
    <el-form ref="form" :model="form" :disabled="form.registerState == '1'">
      <el-form-item label="案由" :label-width="formLabelWidth">
        <el-input v-model="form.casePoint"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="开始时间" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.beginTime"
              type="datetime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="结束时间" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.endTime"
              type="datetime"
              :value-format="`yyyy-MM-dd HH:mm:ss`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="地点" :label-width="formLabelWidth">
        <el-input v-model="form.place"></el-input>
      </el-form-item>
      <el-form-item label="听证方式" :label-width="formLabelWidth">
        <el-input v-model="form.hearingType"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="听证主持人" :label-width="formLabelWidth">
            <el-input v-model="form.hostOfHearing"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="职  务" :label-width="formLabelWidth">
            <el-input v-model="form.post"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="听证记录人" :label-width="formLabelWidth">
            <el-input v-model="form.noteTaker"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="听证员" :label-width="formLabelWidth">
            <el-input v-model="form.hearingOfficer"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="工作单位" :label-width="formLabelWidth">
        <el-input v-model="form.workUnit"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="案件调查人1" :label-width="formLabelWidth">
            <el-input v-model="form.caseInvestigatorOne"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法证号" :label-width="formLabelWidth">
            <el-input v-model="form.certificateNumberOne"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="案件调查人2" :label-width="formLabelWidth">
            <el-input v-model="form.caseInvestigatorTwo"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="执法证号" :label-width="formLabelWidth">
            <el-input v-model="form.certificateNumberTwo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <!--当事人及联系人-->
      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人" :label-width="formLabelWidth">
            <el-input v-model="form.litigant"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="负责人" :label-width="formLabelWidth">
            <el-input v-model="form.legalPerson"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话" :label-width="formLabelWidth">
            <el-input v-model="form.phone"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="地址" :label-width="formLabelWidth">
        <el-input v-model="form.address"></el-input>
      </el-form-item>
      <!--委托代理人1-->
      <el-row>
        <el-col :span="12">
          <el-form-item label="代理人1" :label-width="formLabelWidth">
            <el-input v-model="form.agentOne"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="身份证号" :label-width="formLabelWidth">
            <el-input v-model="form.idCardOne"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="工作单位" :label-width="formLabelWidth">
        <el-input v-model="form.workUnitOne"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="电话" :label-width="formLabelWidth">
            <el-input v-model="form.phoneOne"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <!--委托代理人2-->
      <el-row>
        <el-col :span="12">
          <el-form-item label="代理人2" :label-width="formLabelWidth">
            <el-input v-model="form.agentTwo"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="身份证号" :label-width="formLabelWidth">
            <el-input v-model="form.idCardTwo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="工作单位" :label-width="formLabelWidth">
        <el-input v-model="form.workUnitTwo"></el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="电话" :label-width="formLabelWidth">
            <el-input v-model="form.phoneTwo"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="证人" :label-width="formLabelWidth">
            <el-input v-model="form.witness"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="其他人员" :label-width="formLabelWidth">
            <el-input v-model="form.other"></el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="听证原因" :label-width="formLabelWidth">
        <el-input v-model="form.reason"></el-input>
      </el-form-item>
      <el-form-item label="听证请求" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.hearingRequest"></el-input>
      </el-form-item>
      <el-form-item label="事实、证据" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.hearingRecommendations"></el-input>
      </el-form-item>
      <el-form-item label="当事人陈述" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.litigantStatement"></el-input>
      </el-form-item>
      <el-form-item label="其他内容" :label-width="formLabelWidth">
        <el-input type="textarea" v-model="form.otherContent"></el-input>
      </el-form-item>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center;">
      <el-button v-show="form.registerState != '1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-show="form.registerState != '1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/recordOfHearing";
import moment from "moment";

export default {
  name: "recordOfHearing",
  props: ['isShowYulan', 'id', 'isFinish', 'processId', 'title'],
  components: {
    WordView
  },
  data() {
    return {
      showView: false,
      form: {
        casePoint:"",
        beginTime:"",
        endTime:"",
        place:"",
        hearingType:"",
        hostOfHearing:"",
        post:"",
        noteTaker:"",
        hearingOfficer:"",
        workUnit:"",
        caseInvestigatorOne:"",
        certificateNumberOne:"",
        caseInvestigatorTwo:"",
        certificateNumberTwo:"",
        litigant:"",
        legalPerson:"",
        phone:"",
        address:"",
        agentOne:"",
        idCardOne:"",
        workUnitOne:"",
        phoneOne:"",
        agentTwo:"",
        idCardTwo:"",
        workUnitTwo:"",
        phoneTwo:"",
        witness:"",
        other:"",
        reason:"",
        hearingRequest:"",
        hearingRecommendations:"",
        litigantStatement:"",
        otherContent:"",
      },
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      /*getObj(this.id).then((res) => {
        if (res.success) {
          // 转换null为""
          let v = res.result;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.form = data;
        }
      });*/
      this.getBiLu()
    },
    getBiLu() {
      getObj(this.id).then(res => {
        // this.form = res.data.data
        // 转换null为""
        let v = res.data.data
        for (let attr in v) {
          if (v[attr] == null) {
            v[attr] = "";
          }
        }
        // let str = JSON.stringify(v);
        // let data = JSON.parse(str);
        this.form = v;
      })
    },
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/recordOfHearing.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/recordOfHearing.docx", this.title+'.docx');
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.beginTime != '' && data.beginTime != null) {
        data.beginTime = moment(data.beginTime).format('YYYY年MM月DD日HH时mm分');
      } else {
        data.beginTime = '  年  月  日  时  分'
      }

      if (data.endTime != '' && data.endTime != null) {
        data.endTime = moment(data.endTime).format('HH时mm分');
      } else {
        data.endTime = '  时  分'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
